/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreElementnote.TCoreElementnotePath;
import de.ship.db.tables.TCoreElementtype.TCoreElementtypePath;
import de.ship.db.tables.TCoreLogictype.TCoreLogictypePath;
import de.ship.db.tables.TCoreMissingmaster.TCoreMissingmasterPath;
import de.ship.db.tables.TCorePublic.TCorePublicPath;
import de.ship.db.tables.TCoreScale.TCoreScalePath;
import de.ship.db.tables.TCoreStage.TCoreStagePath;
import de.ship.db.tables.TCoreTranslation.TCoreTranslationPath;
import de.ship.db.tables.TCoreUnit.TCoreUnitPath;
import de.ship.db.tables.TDmRecipient.TDmRecipientPath;
import de.ship.db.tables.TInputLabel.TInputLabelPath;
import de.ship.db.tables.TInputType.TInputTypePath;
import de.ship.db.tables.TInputTypeparam.TInputTypeparamPath;
import de.ship.db.tables.TInputTypeparamlist.TInputTypeparamlistPath;
import de.ship.db.tables.records.TCoreTranslationKeyRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreTranslationKey extends TableImpl<TCoreTranslationKeyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_translation_key</code>
     */
    public static final TCoreTranslationKey T_CORE_TRANSLATION_KEY = new TCoreTranslationKey();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreTranslationKeyRecord> getRecordType() {
        return TCoreTranslationKeyRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_translation_key.pk</code>.
     */
    public final TableField<TCoreTranslationKeyRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_translation_key.translation_key</code>.
     * language key
     */
    public final TableField<TCoreTranslationKeyRecord, String> TRANSLATION_KEY = createField(DSL.name("translation_key"), SQLDataType.CLOB.nullable(false), this, "language key");

    /**
     * The column <code>common_dd.t_core_translation_key.lastchange</code>.
     */
    public final TableField<TCoreTranslationKeyRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreTranslationKey(Name alias, Table<TCoreTranslationKeyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreTranslationKey(Name alias, Table<TCoreTranslationKeyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_translation_key</code> table
     * reference
     */
    public TCoreTranslationKey(String alias) {
        this(DSL.name(alias), T_CORE_TRANSLATION_KEY);
    }

    /**
     * Create an aliased <code>common_dd.t_core_translation_key</code> table
     * reference
     */
    public TCoreTranslationKey(Name alias) {
        this(alias, T_CORE_TRANSLATION_KEY);
    }

    /**
     * Create a <code>common_dd.t_core_translation_key</code> table reference
     */
    public TCoreTranslationKey() {
        this(DSL.name("t_core_translation_key"), null);
    }

    public <O extends Record> TCoreTranslationKey(Table<O> path, ForeignKey<O, TCoreTranslationKeyRecord> childPath, InverseForeignKey<O, TCoreTranslationKeyRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_TRANSLATION_KEY);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreTranslationKeyPath extends TCoreTranslationKey implements Path<TCoreTranslationKeyRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreTranslationKeyPath(Table<O> path, ForeignKey<O, TCoreTranslationKeyRecord> childPath, InverseForeignKey<O, TCoreTranslationKeyRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreTranslationKeyPath(Name alias, Table<TCoreTranslationKeyRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreTranslationKeyPath as(String alias) {
            return new TCoreTranslationKeyPath(DSL.name(alias), this);
        }

        @Override
        public TCoreTranslationKeyPath as(Name alias) {
            return new TCoreTranslationKeyPath(alias, this);
        }

        @Override
        public TCoreTranslationKeyPath as(Table<?> alias) {
            return new TCoreTranslationKeyPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreTranslationKeyRecord, Integer> getIdentity() {
        return (Identity<TCoreTranslationKeyRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreTranslationKeyRecord> getPrimaryKey() {
        return Keys.PK_CORE_LANGUAGEDEFS;
    }

    @Override
    public List<UniqueKey<TCoreTranslationKeyRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_LANG_KEY);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, null, Keys.T_CORE_ELEMENT_HIERARCHY__FK_HIER_LANG.getInverseKey());

        return _tCoreElementHierarchy;
    }

    private transient TCoreElementnotePath _tCoreElementnote;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_elementnote</code> table
     */
    public TCoreElementnotePath tCoreElementnote() {
        if (_tCoreElementnote == null)
            _tCoreElementnote = new TCoreElementnotePath(this, null, Keys.T_CORE_ELEMENTNOTE__FK_NOTE_LANG.getInverseKey());

        return _tCoreElementnote;
    }

    private transient TCoreElementtypePath _tCoreElementtype;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_elementtype</code> table
     */
    public TCoreElementtypePath tCoreElementtype() {
        if (_tCoreElementtype == null)
            _tCoreElementtype = new TCoreElementtypePath(this, null, Keys.T_CORE_ELEMENTTYPE__FK_ELEMENTTYPE_LANG.getInverseKey());

        return _tCoreElementtype;
    }

    private transient TCoreLogictypePath _tCoreLogictype;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_logictype</code> table
     */
    public TCoreLogictypePath tCoreLogictype() {
        if (_tCoreLogictype == null)
            _tCoreLogictype = new TCoreLogictypePath(this, null, Keys.T_CORE_LOGICTYPE__FK_LOGICTYPE_DESCR.getInverseKey());

        return _tCoreLogictype;
    }

    private transient TCoreMissingmasterPath _tCoreMissingmaster;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_missingmaster</code> table
     */
    public TCoreMissingmasterPath tCoreMissingmaster() {
        if (_tCoreMissingmaster == null)
            _tCoreMissingmaster = new TCoreMissingmasterPath(this, null, Keys.T_CORE_MISSINGMASTER__FK_MISSINGMASTER_LANG.getInverseKey());

        return _tCoreMissingmaster;
    }

    private transient TCorePublicPath _tCorePublic;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_public</code> table
     */
    public TCorePublicPath tCorePublic() {
        if (_tCorePublic == null)
            _tCorePublic = new TCorePublicPath(this, null, Keys.T_CORE_PUBLIC__FK_PUBLIC_LANG.getInverseKey());

        return _tCorePublic;
    }

    private transient TCoreScalePath _tCoreScale;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_scale</code> table
     */
    public TCoreScalePath tCoreScale() {
        if (_tCoreScale == null)
            _tCoreScale = new TCoreScalePath(this, null, Keys.T_CORE_SCALE__FK_SCALE_LANG.getInverseKey());

        return _tCoreScale;
    }

    private transient TCoreStagePath _tCoreStage;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_stage</code> table
     */
    public TCoreStagePath tCoreStage() {
        if (_tCoreStage == null)
            _tCoreStage = new TCoreStagePath(this, null, Keys.T_CORE_STAGE__FK_STAGE_LANG.getInverseKey());

        return _tCoreStage;
    }

    private transient TCoreTranslationPath _tCoreTranslation;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_translation</code> table
     */
    public TCoreTranslationPath tCoreTranslation() {
        if (_tCoreTranslation == null)
            _tCoreTranslation = new TCoreTranslationPath(this, null, Keys.T_CORE_TRANSLATION__FK_TRANS_KEY.getInverseKey());

        return _tCoreTranslation;
    }

    private transient TCoreUnitPath _tCoreUnit;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_unit</code> table
     */
    public TCoreUnitPath tCoreUnit() {
        if (_tCoreUnit == null)
            _tCoreUnit = new TCoreUnitPath(this, null, Keys.T_CORE_UNIT__FK_TRANSLATION_KEY.getInverseKey());

        return _tCoreUnit;
    }

    private transient TDmRecipientPath _tDmRecipient;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_recipient</code> table
     */
    public TDmRecipientPath tDmRecipient() {
        if (_tDmRecipient == null)
            _tDmRecipient = new TDmRecipientPath(this, null, Keys.T_DM_RECIPIENT__FK_RECIP_LANG.getInverseKey());

        return _tDmRecipient;
    }

    private transient TInputLabelPath _tInputLabel;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_label</code> table
     */
    public TInputLabelPath tInputLabel() {
        if (_tInputLabel == null)
            _tInputLabel = new TInputLabelPath(this, null, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_LANGKEY.getInverseKey());

        return _tInputLabel;
    }

    private transient TInputTypePath _tInputType;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_type</code> table
     */
    public TInputTypePath tInputType() {
        if (_tInputType == null)
            _tInputType = new TInputTypePath(this, null, Keys.T_INPUT_TYPE__FK_INPUTTYPE_DESCR.getInverseKey());

        return _tInputType;
    }

    private transient TInputTypeparamPath _tInputTypeparam;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_typeparam</code> table
     */
    public TInputTypeparamPath tInputTypeparam() {
        if (_tInputTypeparam == null)
            _tInputTypeparam = new TInputTypeparamPath(this, null, Keys.T_INPUT_TYPEPARAM__FK_INPUTTYPEPARAM_DESCR.getInverseKey());

        return _tInputTypeparam;
    }

    private transient TInputTypeparamlistPath _tInputTypeparamlist;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_typeparamlist</code> table
     */
    public TInputTypeparamlistPath tInputTypeparamlist() {
        if (_tInputTypeparamlist == null)
            _tInputTypeparamlist = new TInputTypeparamlistPath(this, null, Keys.T_INPUT_TYPEPARAMLIST__FK_INPUTTYPEPARAMLIST_LANG.getInverseKey());

        return _tInputTypeparamlist;
    }

    @Override
    public TCoreTranslationKey as(String alias) {
        return new TCoreTranslationKey(DSL.name(alias), this);
    }

    @Override
    public TCoreTranslationKey as(Name alias) {
        return new TCoreTranslationKey(alias, this);
    }

    @Override
    public TCoreTranslationKey as(Table<?> alias) {
        return new TCoreTranslationKey(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreTranslationKey rename(String name) {
        return new TCoreTranslationKey(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreTranslationKey rename(Name name) {
        return new TCoreTranslationKey(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreTranslationKey rename(Table<?> name) {
        return new TCoreTranslationKey(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslationKey where(Condition condition) {
        return new TCoreTranslationKey(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslationKey where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslationKey where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslationKey where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslationKey where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslationKey where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslationKey where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreTranslationKey where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslationKey whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreTranslationKey whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
